/*
 * Chat.java
 *
 * Created on March 6, 2001, 10:04 AM
 */

import java.net.*;

/**
 *
 * @author  s_perron
 * @version 
 */
public class Chat extends javax.swing.JFrame {

    java.io.DataInputStream in;
    java.io.PrintWriter out;
    ReadText t;
    
    /** Creates new form Chat */
    public Chat() {
        initComponents ();
        pack ();
        setSize( 500, 300 );
        ChatArea.setEditable(false);
    }

    public void Connect( java.net.InetAddress address, int port )
    // Will connect to address at the given port.
    {
        try
        {
            Socket sock = new Socket( address, port );
            in = new java.io.DataInputStream( sock.getInputStream() );
            out = new java.io.PrintWriter( sock.getOutputStream() );
            t = new ReadText();
	    t.start();
        }catch( Exception e ){System.out.println( "Problem " + e ); System.exit(1);}
    }
    
    public void Wait(int port)
    // Will wait for another Chat to connect to it, at the given port.
    {
        try {
           java.net.ServerSocket s = new java.net.ServerSocket(port);
           java.net.Socket sock = s.accept();
           in = new java.io.DataInputStream( sock.getInputStream() );
           out = new java.io.PrintWriter( sock.getOutputStream() );
           t = new ReadText();
	   t.start();
	   s.close();
        }catch(Exception e ) {System.out.println( "Problem " + e ); System.exit(1);}
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents () {//GEN-BEGIN:initComponents
        jScrollPane1 = new javax.swing.JScrollPane ();
        ChatArea = new javax.swing.JTextArea ();
        input = new javax.swing.JTextField ();
        addWindowListener (new java.awt.event.WindowAdapter () {
            public void windowClosing (java.awt.event.WindowEvent evt) {
		dispose();
            }
        }
        );
	jScrollPane1.setViewportView (ChatArea);
  

        getContentPane ().add (jScrollPane1, java.awt.BorderLayout.CENTER);

        input.addKeyListener (new java.awt.event.KeyAdapter () {
            public void keyPressed (java.awt.event.KeyEvent evt) {
                inputKeyPressed (evt);
            }
        }
        );


        getContentPane ().add (input, java.awt.BorderLayout.SOUTH);

    }//GEN-END:initComponents

   public void dispose()
   {
   	in = null;
	out = null;
	if( t != null ) t.stop();
   	super.dispose();
   }
   
  private void inputKeyPressed (java.awt.event.KeyEvent evt) {//GEN-FIRST:event_inputKeyPressed
        if( evt.getKeyChar() == '\n' )
        {
            if ( out != null )
            {
                 out.println( input.getText() );
                 out.flush();
            }
            addText( "ME: " + input.getText() );
            input.setText("");
        }
            
  }//GEN-LAST:event_inputKeyPressed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit (0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new Chat ().show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea ChatArea;
    private javax.swing.JTextField input;
    // End of variables declaration//GEN-END:variables

    public synchronized void addText(java.lang.String newText) {
        ChatArea.setText( ChatArea.getText() + newText + '\n' );
    }
    
    public class ReadText extends Thread
    // This class will read the text the other chat
    // sends to you.
    {
        public void run()
        {
            while (true)
            {
                try{
                   String str = in.readLine();
                   addText("OTHER: " + str);
                }
		catch (java.io.IOException e ) {stop();}
            }
        }
    }
}
