import java.awt.Point;
import java.awt.Graphics;

abstract class DrawingShape implements java.io.Serializable, Cloneable
{
    protected Point start, end;

    void move( int right, int down )
    {
	Point p = new Point( start.x+right, start.y+down );
	setStartPoint(p);
	p = new Point( end.x+right, end.y+down );
	setEndPoint(p);
    }

    void setStartPoint( Point p )
    {
	start = p;
    }
    
    void setEndPoint( Point p )
    {
	end = p;
    }
    
    Point getStartPoint()
    {
	return start;
    }
    
    Point getEndPoint()
    {
	return end;
    }
    
    public Object clone() throws CloneNotSupportedException { return super.clone(); }
    abstract void draw( Graphics g );
    abstract boolean contains( Point p );
}
