import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

abstract public class NetworkFrame extends JFrame
{
   protected ObjectOutputStream out;
   protected ObjectInputStream in;
   private int portNumber;
   protected boolean connected = false;
   private Thread reciever;


   public NetworkFrame()
   {
      reciever = new Recieve();
   }
//*******************************************************************

protected void SendEvent( AWTEvent e, int i )
// This function will send an Event to a connected frame.
// (i == 1): the event happened on the window.
// (i > 1 ): the event happened on the (i-2)th menuItem.
{
      if ( connected )
      {
           try
           {
	      if ( !e.toString().endsWith( "on null" ) )
	      {
		  out.writeObject(e);
		  out.writeInt(i);
		  out.flush();
	      }
           }
           catch ( Exception er ) 
           { 
              System.out.println(er); 
           }
      }
}
//*******************************************************************


   private class Recieve extends Thread
   // This thread will read in events and send them to the
   // correct object.
   {
      public void run()
      {
         try
         {
            while( connected )
            {
               AWTEvent e = (AWTEvent)in.readObject();
	           int i = in.readInt();
	              
	           switch(i)
	           {
	           case 1:
		          processEvent( e );
		          break;
	           default:

	              JMenuItem m = getMenuItem(i);

	              if ( m instanceof NetworkMenuItem )
	                 ((NetworkMenuItem)m).processEvent(e);
	              else if ( m instanceof NetworkRadioButtonMenuItem )
	                 ((NetworkRadioButtonMenuItem)m).processEvent(e);
		          break;
	           }
            }
         }
         catch ( Exception e ) 
         { 
            System.out.println("Disconnected");
            in = null;
            out = null;
            connected = false;
         }
      }
   }

//*******************************************************************
   public JMenuItem getMenuItem( int i )
   // Will return the ith menu item.
   {
   	  i -= 2;
   	  int currentMenu = 0;
   	  JMenuBar bar = getJMenuBar();
   	  
   	  while( i+1 > bar.getMenu(currentMenu).getItemCount() )
   	  {
   	  	  i -= bar.getMenu(currentMenu).getItemCount();
   	  	  currentMenu++;
   	  }
   	  
   	  return bar.getMenu(currentMenu).getItem(i);
   }
//*******************************************************************
   private class Wait extends Thread
   {
      public Wait( int p ) { portNumber = p; }

      public void run()
      {
         try
         {
            ServerSocket server = new ServerSocket( portNumber );
            Socket sock = server.accept();
            out =  new ObjectOutputStream( sock.getOutputStream() );
            in = new ObjectInputStream( 
                 new BufferedInputStream( 
                     sock.getInputStream() ) );

            serverInfoTransfer();

            connected = true;
            reciever = new Recieve();
            reciever.start();
         }
         catch( Exception e )
         {
            System.out.println( "Error connecting to client." );
            disconnect();
         }
      }
   }

//*******************************************************************

   public void waitForConnection(int port) { 
       Thread t = new Wait(port);
       t.start();
   }

//*******************************************************************

   abstract protected void serverInfoTransfer() throws Exception;

//*******************************************************************

   abstract protected void clientInfoTransfer() throws Exception;

//*******************************************************************

   public void connect(InetAddress address, int port)
   {
      try
      { 
          Socket sock = new Socket( address, port);
      
          out =  new ObjectOutputStream( sock.getOutputStream() );
          in = new ObjectInputStream( 
               new BufferedInputStream( 
               sock.getInputStream() ) );

          clientInfoTransfer();
          
          connected = true;
          reciever = new Recieve();
          reciever.start(); 
      }
      catch ( Exception e )
      {
      	 System.out.println( "Error connecting to server " + e );
      	 //disconnect();
      }     
   }

//*******************************************************************

   public void disconnect()
   {
   	  try
   	  {
             connected = false;
   	     reciever.stop();
   	     in.close();
   	     out.close();
   	     in = null;
   	     out = null;
   	  }
   	  catch (Exception e ) {}
   }

//*******************************************************************
}
