import java.awt.*;
import java.awt.geom.*;

public class Oval extends DrawingShape
{
    public void draw( Graphics g )
    {
	g.drawOval( Math.min(start.x, end.x), 
                    Math.min(start.y, end.y), 
                    Math.abs(end.x-start.x), 
                    Math.abs(end.y-start.y));
    }

    public boolean contains( Point p )
    {
	Point2D center = new Point2D.Double(((double)start.x+(double)end.x)/2,
					((double)start.y+(double)end.y)/2);
	double a = ((double)start.x-(double)end.x)/2;
	double b = ((double)start.y-(double)end.y)/2;

	return Math.pow(p.x-center.getX(), 2)/Math.pow(a, 2) +
	       Math.pow(p.y-center.getY(), 2)/Math.pow(b, 2) < 1;
    }
}
